<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="人员三类GUID" prop="persTtsGuid">
        <el-input v-model="queryParams.persTtsGuid" placeholder="请输入人员三类GUID" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="申请状态" prop="applStat">
        <el-select v-model="queryParams.applStat" placeholder="请选择申请状态" clearable>
          <el-option v-for="dict in ttsa_appl_stat" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['ttsa:objttsa:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['ttsa:objttsa:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['ttsa:objttsa:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['ttsa:objttsa:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" storageKey="ttsa-objttsa-index"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="人员三类GUID" prop="persTtsGuid" />
      <el-table-column label="申请状态" prop="applStat" width="120">
        <template #default="scope">
          <dict-tag :options="ttsa_appl_stat" :value="scope.row.applStat" />
        </template>
      </el-table-column>
      <el-table-column label="审核状态" prop="veriStat" width="120">
        <template #default="scope">
          <dict-tag :options="ttsa_veri_stat" :value="scope.row.veriStat" />
        </template>
      </el-table-column>
      <el-table-column label="审批状态" prop="apprStat" width="120">
        <template #default="scope">
          <dict-tag :options="ttsa_appl_stat" :value="scope.row.apprStat" />
        </template>
      </el-table-column>
      <el-table-column label="审核时间" prop="veriTime" width="180" />
      <el-table-column label="审批时间" prop="apprTime" width="180" />
      <el-table-column label="操作" align="center" width="200">
        <template #default="scope">
          <el-tooltip content="修改" placement="top">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['ttsa:objttsa:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['ttsa:objttsa:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="650px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="人员三类GUID" prop="persTtsGuid">
          <el-input v-model="form.persTtsGuid" placeholder="请输入人员三类GUID" />
        </el-form-item>
        <el-form-item label="申请状态" prop="applStat">
          <el-select v-model="form.applStat" placeholder="请选择申请状态">
            <el-option v-for="dict in ttsa_appl_stat" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="审核状态" prop="veriStat">
          <el-select v-model="form.veriStat" placeholder="请选择审核状态">
            <el-option v-for="dict in ttsa_veri_stat" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="审核意见" prop="veriOpin">
          <el-input v-model="form.veriOpin" type="textarea" placeholder="请输入审核意见" />
        </el-form-item>
        <el-form-item label="审批状态" prop="apprStat">
          <el-input v-model="form.apprStat" placeholder="请输入审批状态" />
        </el-form-item>
        <el-form-item label="审批意见" prop="apprOpin">
          <el-input v-model="form.apprOpin" type="textarea" placeholder="请输入审批意见" />
        </el-form-item>
        <el-form-item label="审核人" prop="veriPers">
          <el-input v-model="form.veriPers" placeholder="请输入审核人" />
        </el-form-item>
        <el-form-item label="审核时间" prop="veriTime">
          <el-date-picker v-model="form.veriTime" type="datetime" placeholder="选择审核时间" clearable />
        </el-form-item>
        <el-form-item label="审批人" prop="apprPers">
          <el-input v-model="form.apprPers" placeholder="请输入审批人" />
        </el-form-item>
        <el-form-item label="审批时间" prop="apprTime">
          <el-date-picker v-model="form.apprTime" type="datetime" placeholder="选择审批时间" clearable />
        </el-form-item>
        <el-form-item label="考试状态" prop="examStat">
          <el-input v-model="form.examStat" placeholder="请输入考试状态" />
        </el-form-item>
        <el-form-item label="考试申请GUID" prop="examApplGuid">
          <el-input v-model="form.examApplGuid" placeholder="请输入考试申请GUID" />
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="ObjTtsa">
import { listObjTtsa, getObjTtsa, addObjTtsa, updateObjTtsa, delObjTtsa } from "@/api/slaj/ttsa";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();
const { ttsa_appl_stat, ttsa_veri_stat } = proxy.useDict("ttsa_appl_stat", "ttsa_veri_stat");

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const columns = ref({ persTtsGuid: { visible: true }, applStat: { visible: true }, veriStat: { visible: true }, apprStat: { visible: true }, veriTime: { visible: true }, apprTime: { visible: true } });

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, persTtsGuid: null, applStat: null },
  rules: {}
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listObjTtsa(queryParams.value).then(r => {
    dataList.value = r.rows;
    total.value = r.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(s) {
  ids.value = s.map(i => i.guid);
  single.value = s.length !== 1;
  multiple.value = !s.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加安全考核申请";
}

function handleUpdate(row) {
  reset();
  getObjTtsa(row.guid || ids.value[0]).then(r => {
    form.value = r.data;
    open.value = true;
    title.value = "修改安全考核申请";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(v => {
    if (v) {
      if (form.value.guid != null) {
        updateObjTtsa(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addObjTtsa(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('确认删除？').then(() => delObjTtsa(row.guid || ids.value.join(","))).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/ttsa/objttsa/export', { ...queryParams.value }, `安全考核申请_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { guid: null, persTtsGuid: null, applStat: null, veriStat: null, veriOpin: null, apprStat: null, apprOpin: null, veriPers: null, veriTime: null, apprPers: null, apprTime: null, examStat: null, examApplGuid: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
